// VMware Virtualization Wizard Javascript and jQuery include file
// Copyright 2014-10-23 Nagios Enterprises, LLC
  
// I want all ajax calls to be performed synchronously
$.ajaxSetup({
	async: false
	}); // End $.ajaxSetup({


function vmwarevirtualizationwizard_ToggleMenu(a) {
	//alert(a);
	// hide all menu elements 
   	$('.vmwarevirtualizationwizard-togglediv').hide(); 
	// reset the last item that was selected
	$('.vmwarevirtualizationwizard-menuheading2').addClass("vmwarevirtualizationwizard-menuheading1").removeClass("vmwarevirtualizationwizard-menuheading2");
	// show the selected menu element
	$('#' + a).show(); 
	// Style the currently selected menu item
	$('#id-' + a).addClass("vmwarevirtualizationwizard-menuheading2").removeClass("vmwarevirtualizationwizard-menuheading1");
	} // End function vmwarevirtualizationwizard_ToggleMenu(a) {


function vmwarevirtualizationwizard_toggleMe(a) {
	$('#'+ a).slideToggle();
	} // End function vmwarevirtualizationwizard_toggleMe(a) {


function vmwarevirtualizationwizard_vma_host_select(vma_options) {
	// Get the vMA host selected
	var vma_host_address = $('#id_vma_host_select option:selected').val();
	
	// Define the DIV ID we are going to load
	var div_id = '#vmwarevirtualizationwizard-display-host';

	// Get the vMA host object selected
	var vma_host_object_select_setting = $('#id_vma_host_object_select_setting').val();
	//alert("vMA Host object is: " + vma_host_object_select_setting);

	// Get the Guest Checkbox Settings
	var vmware_object_radio_list_serial = $('#vmware_object_radio_list_serial').val();
	
	// Load the DIV
	$(div_id).load('/nagiosxi/includes/configwizards/vmwarevirtualizationwizard/vmwarevirtualizationwizard_misc.php?request=vma_host_select&vma_options=' + vma_options + '&vma_address=' + encodeURIComponent(vma_host_address) + '&vma_host_object_select_setting=' + encodeURIComponent(vma_host_object_select_setting) + '&vmware_object_radio_list_serial=' + vmware_object_radio_list_serial);

	// Show the DIV
	$(div_id).show();
	
	} // End function vmwarevirtualizationwizard_vma_host_select(vma_options) {


function vmwarevirtualizationwizard_vmware_check_select() {
	// Get the vMA host selected
	var vma_host_address = $('#id_vma_host_select option:selected').val();
	
	// Get the vMA Host Settings List
	var vma_host_settings_list_serial = $('#vma_host_settings_list_serial').val();
	
	// Get the vMA Host Object Selected
	var vma_host_object_select = $('#id_vma_host_object_select option:selected').val();

	// Get the VMware Check Type Setting
	var vmware_check_type_setting = $('#id_vmware_check_type_setting').val();

	// Define the DIV ID we are going to load
	var div_id = '#vmwarevirtualizationwizard-display-check-type';
	
	// Load the DIV
	$(div_id).load('/nagiosxi/includes/configwizards/vmwarevirtualizationwizard/vmwarevirtualizationwizard_misc.php?request=vmware_check_select'  + '&vma_host_address=' + encodeURIComponent(vma_host_address) + '&vma_host_settings_list_serial=' + vma_host_settings_list_serial + '&vma_host_object_select=' + encodeURIComponent(vma_host_object_select) + '&vmware_check_type_setting=' + vmware_check_type_setting);

	// Show the DIV
	$(div_id).show();
	} // End function vmwarevirtualizationwizard_vmware_check_select() {


function vmwarevirtualizationwizard_vmware_retrieve_button() {
	// Get the VMware Check Type selected
	var vmware_check_type = $('#id_vmware_check_type option:selected').val();
	
	// Define the DIV ID we are going to load
	var div_id = '#vmwarevirtualizationwizard-retrieve-button';

	// Load the DIV
	$(div_id).load('/nagiosxi/includes/configwizards/vmwarevirtualizationwizard/vmwarevirtualizationwizard_misc.php?request=retrieve_button_' + vmware_check_type);

	// Show the DIV
	$(div_id).show();

	// Define the DIV ID we are going to hide
	div_id = '#vmwarevirtualizationwizard-retrieve-results';

	// Hide the DIV
	$(div_id).hide();
	
	} // End function vmwarevirtualizationwizard_vmware_retrieve_button() {


function vmwarevirtualizationwizard_get_objects(input_objects) {
	var input_objects_split = input_objects.split(':');

	// Define the DIV ID we are going to load
	var div_id = '#' + input_objects_split[0];

	// Hide the DIV
	$(div_id).hide();
	
	// Define the request
	var request = input_objects_split[1];

	// Define the throbber DIV
	var div_id_throbber = '#vmwarevirtualizationwizard-retrieve-throbber';

	// Show the throbber DIV
	$(div_id_throbber).show();
	
	// Get the vMA Host
	var vma_host_select = $('#id_vma_host_select').val();

	// Get the vMA Object
	var vma_host_object_select = $('#id_vma_host_object_select').val();

	// Get the vMA Object Type
	var vma_host_object_type = $('#id_vmware_object_type').val();

	// Get the Nagios Object Select Values
	var nagios_object_settings_serial = $('#id_nagios_object_settings_serial').val();
	
	// Get the Nagios Object Existing Values
	var nagios_object_existing_settings_serial = $('#id_nagios_object_existing_settings_serial').val();
	
	// Get the Nagios Object New Name Values
	var nagios_object_new_name_settings_serial = $('#id_nagios_object_new_name_settings_serial').val();
	
	// Get the Nagios Object New Address Values
	var nagios_object_new_address_settings_serial = $('#id_nagios_object_new_address_settings_serial').val();
	
	switch (request) {
		case 'retrieve_datastores':
			// Get the Datastore Checkbox Settings
			var datastore_checkbox_settings_serial = $('#id_datastore_checkbox_settings_serial').val();
			
			// Load the DIV
			$(div_id).load('/nagiosxi/includes/configwizards/vmwarevirtualizationwizard/vmwarevirtualizationwizard_misc.php?request=' + request + '&vma_host_select=' + encodeURIComponent(vma_host_select) + '&vma_host_object_select=' + encodeURIComponent(vma_host_object_select) + '&vma_host_object_type=' + encodeURIComponent(vma_host_object_type) + '&nagios_object_existing_settings_serial=' + nagios_object_existing_settings_serial + '&datastore_checkbox_settings_serial=' + datastore_checkbox_settings_serial + '&nagios_object_settings_serial=' + nagios_object_settings_serial + '&nagios_object_new_name_settings_serial=' + nagios_object_new_name_settings_serial + '&nagios_object_new_address_settings_serial=' + nagios_object_new_address_settings_serial);
			break; // End case 'retrieve_datastores':
			

		case 'retrieve_guests':
			// Get the Guest Checkbox Settings
			var guest_checkbox_settings_serial = $('#id_guest_checkbox_settings_serial').val();
			
			// Load the DIV
			$(div_id).load('/nagiosxi/includes/configwizards/vmwarevirtualizationwizard/vmwarevirtualizationwizard_misc.php?request=' + request + '&vma_host_select=' + encodeURIComponent(vma_host_select) + '&vma_host_object_select=' + encodeURIComponent(vma_host_object_select) + '&vma_host_object_type=' + encodeURIComponent(vma_host_object_type) + '&nagios_object_existing_settings_serial=' + nagios_object_existing_settings_serial + '&guest_checkbox_settings_serial=' + guest_checkbox_settings_serial + '&nagios_object_settings_serial=' + nagios_object_settings_serial + '&nagios_object_new_name_settings_serial=' + nagios_object_new_name_settings_serial + '&nagios_object_new_address_settings_serial=' + nagios_object_new_address_settings_serial);
			break; // End case 'retrieve_guests':
			

		case 'retrieve_hosts':
			// Get the Host Checkbox Settings
			var host_checkbox_settings_serial = $('#id_host_checkbox_settings_serial').val();
			
			// Load the DIV
			$(div_id).load('/nagiosxi/includes/configwizards/vmwarevirtualizationwizard/vmwarevirtualizationwizard_misc.php?request=' + request + '&vma_host_select=' + encodeURIComponent(vma_host_select) + '&vma_host_object_select=' + encodeURIComponent(vma_host_object_select) + '&vma_host_object_type=' + encodeURIComponent(vma_host_object_type) + '&nagios_object_existing_settings_serial=' + nagios_object_existing_settings_serial + '&host_checkbox_settings_serial=' + host_checkbox_settings_serial + '&nagios_object_settings_serial=' + nagios_object_settings_serial + '&nagios_object_new_name_settings_serial=' + nagios_object_new_name_settings_serial + '&nagios_object_new_address_settings_serial=' + nagios_object_new_address_settings_serial);
			break; // End case 'retrieve_hosts':


		case 'retrieve_vcenter':
			// Get the vCenter Checkbox Settings
			var vcenter_checkbox_settings_serial = $('#id_vcenter_checkbox_settings_serial').val();
			
			// Load the DIV
			$(div_id).load('/nagiosxi/includes/configwizards/vmwarevirtualizationwizard/vmwarevirtualizationwizard_misc.php?request=' + request + '&vma_host_select=' + encodeURIComponent(vma_host_select) + '&vma_host_object_select=' + encodeURIComponent(vma_host_object_select) + '&vma_host_object_type=' + encodeURIComponent(vma_host_object_type) + '&nagios_object_existing_settings_serial=' + nagios_object_existing_settings_serial + '&vcenter_checkbox_settings_serial=' + vcenter_checkbox_settings_serial + '&nagios_object_settings_serial=' + nagios_object_settings_serial + '&nagios_object_new_name_settings_serial=' + nagios_object_new_name_settings_serial + '&nagios_object_new_address_settings_serial=' + nagios_object_new_address_settings_serial);
			break; // End case 'retrieve_vcenter':
		} /* End switch (request) { */

	// Hide the throbber DIV
	$(div_id_throbber).hide();
	
	// Show the DIV
	$(div_id).show();
	
	} // End function vmwarevirtualizationwizard_get_objects() {


function vmwarevirtualizationwizard_nagios_host_object(object_counter) {
	//alert('object_counter: ' + object_counter)

	// Get the value of the Nagios Host Object Select
	var nagios_object_select = $('#id_nagios_object\\[' + object_counter + '\\] option:selected').val();
	//alert('nagios_object_select: ' + nagios_object_select)

	//Now show the selected DIV and hide the other
	switch (nagios_object_select) {
		case 'new':
			$('#vmwarevirtualizationwizard-nagios-object-existing-' + object_counter).hide();
			$('#vmwarevirtualizationwizard-nagios-object-new-' + object_counter).show();
			break; // End case 'new':
			
		case 'existing':
			$('#vmwarevirtualizationwizard-nagios-object-new-' + object_counter).hide();
			$('#vmwarevirtualizationwizard-nagios-object-existing-' + object_counter).show();
			break; // End case 'existing':
		} // End switch (nagios_object_select) {

	} // End function vmwarevirtualizationwizard_nagios_host_object(object_counter) {


function vmwarevirtualizationwizard_ToggleCheckbox(input_objects) {
	var input_objects_split = input_objects.split(':');
	var checkbox_id = '#' + input_objects_split[0];
	var checkbox_class = "." + input_objects_split[1];
	
	//alert("begin " + checkbox_id + " value is: " + $(checkbox_id).val());
	if ($(checkbox_id).val().match(/off$/)) {
		//window.alert('it was off ');
		$(checkbox_id).attr('value', 'on');				
		$(checkbox_class).attr('checked', true);
		} // End if ($(checkbox_id).val().match(/off$/)) {
	else if ($(checkbox_id).val().match(/on$/)) {
		//window.alert('it was on ');
		$(checkbox_id).attr('value', 'off');
		$(checkbox_class).attr('checked', false);	
		} // End else if ($(checkbox_id).val().match(/on$/)) {
	//alert("end " + checkbox_id + " value is: " + $(checkbox_id).val());
	} // End function vmwarevirtualizationwizard_ToggleCheckbox(a) {


function vmwarevirtualizationwizard_RandomizeCheckInterval(input_objects) {
	var input_objects_split = input_objects.split(',');

	var object_type = input_objects_split[0];
	//alert(object_type);
	var options_type = input_objects_split[1];
	//alert(options_type);
	
	// Get the min value
	var min_value = Math.floor($('[name=\'randomizer[' + object_type + '][check_interval][min]\']').val());
	//alert('min_value: ' + min_value);
	// Test min_value
	if ($.isNumeric(min_value) == false) {
		alert(object_type + ' Min field is NOT a number!');
		} // End if ($.isNumeric(min_value) == false) {
	else {
		// Get the max value
		var max_value = Math.floor($('[name=\'randomizer[' + object_type + '][check_interval][max]\']').val());
		//alert('max_value: ' + max_value);
		// Test max_value
		if ($.isNumeric(max_value) == false) {
			alert(object_type + ' Max field is NOT a number!');
			} // End if ($.isNumeric(max_value) == false) {
		else {
			// Check to make sure the max value and min value are not the same number
			if (max_value == min_value) {
				alert(object_type + ' The Max value "' + max_value + '" and the Min value "' + min_value + '" CANNOT be the SAME number!');
				} // End if (max_value == min_value) {
			else {
				// Check to make sure the max value is larger than the min value
				if (max_value < min_value) {
					alert(object_type + ' The Max value "' + max_value + '" MUST be larger than the Min value "' + min_value + '" !');
					} // End if (max_value < min_value) {
				else {
					// Do it
					// Get the objects used
					objects_used = JSON.parse($('#id_objects_used').val());
					//alert(objects_used);

					switch (object_type) {
						case 'Host_Datastore_Performance':
							// Get the list of datastores
							$('#id_propagate_options_' + object_type + ' option').each(function() {
								//alert($(this).val());
								var object_selected_split = $(this).val().split('~');

								// Now generate a random check interval value and propagate to all relevent object check_interval fields
								var random_number = Math.floor(Math.random() * (max_value - min_value + 1)) + min_value;

								// Set the value
								$('[name=\'' + options_type + '[' + object_type + ']' + object_selected_split[0] + '[check_interval][' + object_selected_split[1] + ']\']').val(random_number);
								}); // End $('#id_propagate_options_' + object_type + ' option').each(function() {
							break; // End case 'Host_Datastore_Performance':

						default:
							// Now generate a random check interval value and propagate to all relevent object check_interval fields
							for (var objects_counter = 0; objects_counter < objects_used.length; objects_counter++) {
								var random_number = Math.floor(Math.random() * (max_value - min_value + 1)) + min_value;
								//alert('random_number: ' + random_number);
								
								// Set the value
								$('[name=\'' + options_type + '[' + object_type + '][check_interval][' + objects_used[objects_counter] + ']\']').val(random_number);
								} // End for (var objects_counter = 0; objects_counter < objects_used.length; objects_counter++) {
							break; // End default:
						} // End switch (object_type) {
					
					} // End else {
				} // End else {
			} // End else {
		} // End else {
	} // End function vmwarevirtualizationwizard__RandomizeCheckInterval(object_type) {



function vmwarevirtualizationwizard_PropagateCommonOptions(input_objects) {
	//alert(input_objects);
	var input_objects_split = input_objects.split(',');
	
	// Get the Type
	var type = input_objects_split[0].split(':');

	// Get the options type
	var options_type = type[0];
	//alert('options_type: ' + options_type);
	// Get the object type
	var object_type = type[1];
	//alert('object_type: ' + object_type);
	// Get the object we are going to gather the common options from
	var object_selected = $('#id_propagate_options_' + object_type + ' option:selected').val();
	//alert('object_selected: ' + object_selected);

	if (object_type == 'Host_Datastore_Performance') {
		var object_selected_original = object_selected;
		//alert('object_selected_original: ' + object_selected_original);
		} // End if (object_type == 'Host_Datastore_Performance') {
	
	// Define object for storing pulled values
	var pulled_values = {};
	
	// Get the list of options
	var input_options_split = input_objects_split[1].split('~');
	for (var counter = 0; counter < input_options_split.length; counter++) {
		// Get the current option
		var current_options_split = input_options_split[counter].split(':');
		var current_option_name = current_options_split[0];
		var object_name = current_options_split[0];
		var current_option_type = current_options_split[1];

		if (object_type == 'Host_Datastore_Performance') {
			var object_selected_original_split = object_selected_original.split('~');
			object_selected = object_selected_original_split[1];
			current_option_name = object_selected_original_split[0] + current_option_name;
			//alert('object_selected_original_split[1]: ' + object_selected_original_split[1]);
			//alert('object_selected: ' + object_selected);
			//alert('current_option_name: ' + current_option_name);
			} // End if (object_type == 'Host_Datastore_Performance') {

		
		// Now get the current options
		switch (current_option_type) {
			case 'checkbox':
				// Get the value
				var pulled_value = $('[name=\'' + options_type + '[' + object_type + ']' + current_option_name + '[' + object_selected + ']\']').attr('checked');
				// Add the value to the object
				pulled_values[object_name] = pulled_value;
				//alert(current_option_name + ': "' + pulled_value + '"');
				break; // End case 'checkbox':


			case 'select':
				// Get the value
				var pulled_value = $('[name=\'' + options_type + '[' + object_type + ']' + current_option_name + '[' + object_selected + ']\'] option:selected').val();
				// Add the value to the object
				pulled_values[object_name] = pulled_value;
				//alert(current_option_name + ': ' + pulled_value);
				break; // End case 'select':

			
			case 'select_multiple':
				// Define an array
				var pulled_value = new Array();
				// Get the value
				$('[name=\'' + options_type + '[' + object_type + ']' + current_option_name + '[' + object_selected + ']\'] :selected').each(
					function (i, selected) {
						// Push the value into the array
						pulled_value.push($(selected).val());
						} // End function (i, selected) {
					);
				// Add the value to the object
				pulled_values[object_name] = pulled_value;
				//alert(current_option_name + ': ' + pulled_value);
				break; // End case 'select_multiple':

			
			case 'text':
				// Get the value
				var pulled_value = $('[name=\'' + options_type + '[' + object_type + ']' + current_option_name + '[' + object_selected + ']\']').val();
				// Add the value to the object
				pulled_values[object_name] = pulled_value;
				//alert(current_option_name + ': ' + pulled_value);
				break; // End case 'text':
			} // End switch (current_option_type) {
		} // End for (var counter = 0; counter < input_options_split; counter++) {

	// Get the objects used
	objects_used = JSON.parse($('#id_objects_used').val());
	//alert(objects_used);
	
	
	// Now propagate the pulled values to all the other relevant objects
	for (var objects_counter = 0; objects_counter < objects_used.length; objects_counter++) {
		var counter = objects_used[objects_counter];
		// Skip the object we pulled the values from
		if (counter != object_selected) {
			//alert('counter: ' + counter);
		
			for (var counter_options = 0; counter_options < input_options_split.length; counter_options++) {
				// Get the current option
				var current_options_split = input_options_split[counter_options].split(':');
				var current_option_type = current_options_split[1];

				// Defining object for storing item_name's
				var item_names = {};

				// Define object for storing current_object_name
				var current_object_names = {};
	
				// Adding items to the item_names array
				var item_counter = 0;
				switch (object_type) {
					case 'Host_Datastore_Performance':
						$('#id_propagate_options_' + object_type + ' option').each(function() {
							// Skip the object we pulled the values from
							if ($(this).val() != object_selected_original) {
								var object_selected_split = $(this).val().split('~');
								// Only process the object we are on
								if (object_selected_split[0] == '[' + counter + ']') {
									var datastore_name = object_selected_split[1];
									var current_option_name = current_options_split[0];
									var datastore_current_option_name = object_selected_split[0] + current_option_name;
									current_object_names[item_counter] = current_option_name;
									item_names[item_counter] = '[name=\'' + options_type + '[' + object_type + ']' + datastore_current_option_name + '[' + datastore_name + ']\']';
									item_counter++;
									} // End if (object_selected_split[0] == '[' + counter + ']') {
								} // End if ($(this).val() != object_selected_original) {
							});
						break; // End case 'Host_Datastore_Performance':

					default:
						var current_option_name = current_options_split[0];
						current_object_names[item_counter] = current_option_name;
						item_names[item_counter] = '[name=\'' + options_type + '[' + object_type + ']' + current_option_name + '[' + counter + ']\']';
						item_counter++;
						break; // End default:
					} // End switch (object_type) {
				//alert(item_names);
				//alert(item_names[0]);
				//alert('item_counter: ' + item_counter);

				
				// Propagate the current options
				for (var name_counter = 0; name_counter <= item_counter; name_counter++) {
					switch (current_option_type) {
						case 'checkbox':
							// Set the value
							if (pulled_values[current_object_names[name_counter]] == undefined) {
								$(item_names[name_counter]).attr('checked', false);
								}
							else {
								$(item_names[name_counter]).attr('checked', true);
								} // End else {
							break; // End case 'checkbox':


						case 'select':
							// Set the value
							$(item_names[name_counter]).val(pulled_values[current_object_names[name_counter]]);
							break; // End case 'select':
					

						case 'select_multiple':
							// Set the value
							$(item_names[name_counter]).val(pulled_values[current_object_names[name_counter]]);
							break; // End case 'select_multiple':


						case 'text':
							// Set the value
							$(item_names[name_counter]).val(pulled_values[current_object_names[name_counter]]);
							break; // End case 'text':
						} // End switch (current_option_type) {
					} // End for (var name_counter = 0; name_counter < item_names.length; name_counter++) {
				} // End for (var counter_options = 0; counter_options < input_options_split; counter_options++) {
			} // End if (counter != object_selected) {
		} // End for (var objects_counter = 0; objects_counter < objects_used.length; objects_counter++) {
	} // End function vmwarevirtualizationwizard_PropagateCommonOptions(object_type) {



function vmwarevirtualizationwizard_test() {
	// Define the DIV ID we are going to load
	var div_id = '#vmwarevirtualizationwizard-test';

	// Load the DIV
	$(div_id).load('/nagiosxi/includes/configwizards/vmwarevirtualizationwizard/vmwarevirtualizationwizard_misc.php?request=test');

	// Show the DIV
	$(div_id).show();
	} // End function vmwarevirtualizationwizard_test() {
