<?php
/* VMware Virtualization CONFIG WIZARD */
/* Copyright 2014-10-23 Nagios Enterprises, LLC */

require_once(dirname(__FILE__).'/../../common.inc.php');

// initialization stuff
pre_init();
// start session
init_session();
// grab GET or POST variables 
grab_request_vars();
// check prereqs
check_prereqs();
// check authentication
check_authentication(false);

/* Define the wizard name */
$wizard_name = 'vmwarevirtualizationwizard';
	
/* Define the output */
$vmwarevirtualizationwizard_output = '';


/* Get the request passed to us */
$vmwarevirtualizationwizard_request = grab_request_var('request',false);

/* Process the request */
switch ($vmwarevirtualizationwizard_request) {
	case 'vma_host_select':
		/* Get the vMA Host Address */
		$vma_host_address = urldecode(grab_request_var('vma_address',false));

		/* Get the vMA Host Object Address Selected */
		$vma_host_object_address_setting = urldecode(grab_request_var('vma_host_object_select_setting',false));
		
		/* Get the vMA Host Options */
		$vma_host_settings_list_serial = grab_request_var('vma_options',false);
		$vma_host_settings_list = unserialize(base64_decode($vma_host_settings_list_serial));

		/* Get the vMA Object Radio List */
		$vmware_object_radio_list_serial = grab_request_var('vmware_object_radio_list_serial',false);
		$vmware_object_radio_list = unserialize(base64_decode($vmware_object_radio_list_serial));

		/* Work out what vMA Host Object to Display */
		if ($vma_host_object_address_setting != '') {
			/* It was previously selected */
			$vma_default_vmware_object_address = $vma_host_object_address_setting;
			} /* End if ($vma_host_object_address_setting != 'undefined') { */
		else {
			/* Get the default vmware object */
			if (isset($vmware_object_radio_list[$vma_host_address])) {
				$vma_default_vmware_object_address = $vmware_object_radio_list[$vma_host_address];
				} /* End if (isset($vmware_object_radio_list[$vma_host_address])) { */
			else {
				$vma_default_vmware_object_address = '';
				} /* End else { */
			if ($vma_default_vmware_object_address == '') {
				/* Can't find a default, just use the first vmware object */
				$vma_default_vmware_object_address = $vma_host_settings_list[$vma_host_address][0][0];
				} /* End if ($vma_default_vmware_object_address = '') { */
			} /* End else { */

		/* Build the select list of vmware objects */
		$vmwarevirtualizationwizard_output .= '<select name="vma_host_object_select" id="id_vma_host_object_select" title="vCenter Server or ESX(i) Host" onChange="'.$wizard_name.'_vmware_check_select()">';
		foreach ($vma_host_settings_list[$vma_host_address] as $vmware_object) {
			$vmwarevirtualizationwizard_output .= '<option value="'.$vmware_object[0].'"';
			if ($vmware_object[0] == $vma_default_vmware_object_address) {
				$vmwarevirtualizationwizard_output .= ' selected';
				} /* End if ($vmware_object[0] == $vma_default_vmware_object_address) { */
			$vmwarevirtualizationwizard_output .= '>'.$vmware_object[0].' = ';
			if ($vmware_object[1] == 'vcenter') {
				$vmwarevirtualizationwizard_output .= 'vCenter Server';
				} /* End if ($vmware_object[1] == 'vcenter') { */
			else {
				$vmwarevirtualizationwizard_output .= 'ESX(i) Host';
				} /* End else { */
				$vmwarevirtualizationwizard_output .= '</option>';
			} /* End foreach ($vma_host_settings_list[$vma_host_address] as $vmware_object) { */
		$vmwarevirtualizationwizard_output .= '</select>';

		$vmwarevirtualizationwizard_output .= '<script>'.$wizard_name.'_vmware_check_select()</script>';
		break; /* End case 'vma_host_select': */


	case 'vmware_check_select':
		/* Get the vMA Host Address */
		$vma_host_address = urldecode(grab_request_var('vma_host_address',false));
		
		/* Get the vMA Host Options */
		$vma_host_settings_list_serial = grab_request_var('vma_host_settings_list_serial',false);
		$vma_host_settings_list = unserialize(base64_decode($vma_host_settings_list_serial));

		/* Get the vMA Host Object Selected */
		$vma_host_object_select = urldecode(grab_request_var('vma_host_object_select',false));
		
		/* Get the VMware Default Object Type */
		foreach ($vma_host_settings_list[$vma_host_address] as $vmware_object) {
			if ($vmware_object[0] == $vma_host_object_select) {
				$vmware_object_type = $vmware_object[1];
				} /* End if ($vmware_object[0] == $vma_host_object_select) { */
			} /* End foreach ($vma_host_settings_list[$vma_host_address] as $vmware_object) { */

		/* Get the VMware Check Type Setting */
		$vmware_check_type_setting = grab_request_var('vmware_check_type_setting',false);
		
		$vmwarevirtualizationwizard_output .= '
			<table>
				<tr>
					<td class="'.$wizard_name.'-align-right '.$wizard_name.'-width170">Check Type:</td>
					<td class="'.$wizard_name.'-width10"></td>
					<td class="'.$wizard_name.'-align-left">
			';

		/* Build the select list of vmware checks */
		$vmwarevirtualizationwizard_output .= '<select name="vmware_check_type" id="id_vmware_check_type" title="Check Type" onChange="'.$wizard_name.'_vmware_retrieve_button()">';
		switch ($vmware_object_type) {
			case 'vcenter':
				$vmwarevirtualizationwizard_output .= '<option value="vcenter"'; if ($vmware_check_type_setting == 'vcenter') $vmwarevirtualizationwizard_output .= ' selected'; $vmwarevirtualizationwizard_output .= '>vCenter</option>';
				$vmwarevirtualizationwizard_output .= '<option value="host"'; if ($vmware_check_type_setting == 'host') $vmwarevirtualizationwizard_output .= ' selected'; $vmwarevirtualizationwizard_output .= '>Hosts</option>';
				$vmwarevirtualizationwizard_output .= '<option value="datastores"'; if ($vmware_check_type_setting == 'datastores') $vmwarevirtualizationwizard_output .= ' selected'; $vmwarevirtualizationwizard_output .= '>Datastores</option>';
				$vmwarevirtualizationwizard_output .= '<option value="guests"'; if ($vmware_check_type_setting == 'guests') $vmwarevirtualizationwizard_output .= ' selected'; $vmwarevirtualizationwizard_output .= '>Guests</option>';
				break; /* End case 'vcenter': */

			case 'esx':
				$vmwarevirtualizationwizard_output .= '<option value="host"'; if ($vmware_check_type_setting == 'host') $vmwarevirtualizationwizard_output .= ' selected'; $vmwarevirtualizationwizard_output .= '>Host</option>';
				$vmwarevirtualizationwizard_output .= '<option value="datastores"'; if ($vmware_check_type_setting == 'datastores') $vmwarevirtualizationwizard_output .= ' selected'; $vmwarevirtualizationwizard_output .= '>Datastores</option>';
				$vmwarevirtualizationwizard_output .= '<option value="guests"'; if ($vmware_check_type_setting == 'guests') $vmwarevirtualizationwizard_output .= ' selected'; $vmwarevirtualizationwizard_output .= '>Guests</option>';
				break; /* End case 'esx': */
			} /* End switch ($vmware_object_type) { */
		$vmwarevirtualizationwizard_output .= '
						</select>
					</td>
				</tr>
			</table>

			<div id="'.$wizard_name.'-retrieve-button" style="display:none">
				<!-- This will be populated when a check type is selected from the list -->
			</div>

			<div class="'.$wizard_name.'-spacer10"> </div>
			
			<div id="'.$wizard_name.'-retrieve-throbber" style="display:none">
				'.get_throbber_html().'
			</div>

			<input type="hidden" name="vmware_object_type" id="id_vmware_object_type" value="'.$vmware_object_type.'">

			<script>'.$wizard_name.'_vmware_retrieve_button()</script>
			';
		break; /* End case 'vmware_check_select': */


	case 'retrieve_button_datastores':
		$vmwarevirtualizationwizard_output .= '
			<div class="sectionTitle">Datastores</div>

			<input type="button" onclick="'.$wizard_name.'_get_objects(\''.$wizard_name.'-retrieve-results:retrieve_datastores\')" value="Retrieve Datastores">
			';
		break; /* End case 'retrieve_button_datastores': */


	case 'retrieve_button_guests':
		$vmwarevirtualizationwizard_output .= '
			<div class="sectionTitle">Guests</div>

			<input type="button" onclick="'.$wizard_name.'_get_objects(\''.$wizard_name.'-retrieve-results:retrieve_guests\')" value="Retrieve Guests">
			';
		break; /* End case 'retrieve_button_guests': */


	case 'retrieve_button_host':
		$vmwarevirtualizationwizard_output .= '
			<div class="sectionTitle">Hosts</div>

			<input type="button" onclick="'.$wizard_name.'_get_objects(\''.$wizard_name.'-retrieve-results:retrieve_hosts\')" value="Retrieve Hosts">
			';
		break; /* End case 'retrieve_button_guests': */


	case 'retrieve_button_vcenter':
		$vmwarevirtualizationwizard_output .= '
			<div class="sectionTitle">vCenter Specific</div>

			<input type="button" onclick="'.$wizard_name.'_get_objects(\''.$wizard_name.'-retrieve-results:retrieve_vcenter\')" value="Retrieve vCenter Objects">
			';
		break; /* End case 'retrieve_button_vcenter': */


	case 'retrieve_datastores':
	case 'retrieve_guests':
	case 'retrieve_hosts':
	case 'retrieve_vcenter':
		/* Get the vMA Host */
		$vma_host_select = urldecode(grab_request_var('vma_host_select',false));
		
		/* Get the vMA Object */
		$vma_host_object_select = urldecode(grab_request_var('vma_host_object_select',false));

		/* Get the vMA Object Type */
		$vma_host_object_type = urldecode(grab_request_var('vma_host_object_type',false));

		/* Get the Nagios Object Select Values */
		$nagios_object_settings_serial = urldecode(grab_request_var('nagios_object_settings_serial',false));
		if ($nagios_object_settings_serial != 'undefined') {
			$nagios_object_settings = unserialize(base64_decode($nagios_object_settings_serial));
			} /* End if ($nagios_object_settings_serial != 'undefined') { */
		else {
			$nagios_object_settings = '';
			} /* End else { */

		/* Get the Nagios Object Existing Values */
		$nagios_object_existing_settings_serial = urldecode(grab_request_var('nagios_object_existing_settings_serial',false));
		if ($nagios_object_existing_settings_serial != 'undefined') {
			$nagios_object_existing_settings = unserialize(base64_decode($nagios_object_existing_settings_serial));
			} /* End if ($nagios_object_new_name_settings_serial != 'undefined') { */
		else {
			$nagios_object_existing_settings = '';
			} /* End else { */

		/* Get the Nagios Object New Name Values */
		$nagios_object_new_name_settings_serial = urldecode(grab_request_var('nagios_object_new_name_settings_serial',false));
		if ($nagios_object_new_name_settings_serial != 'undefined') {
			$nagios_object_new_name_settings = unserialize(base64_decode($nagios_object_new_name_settings_serial));
			} /* End if ($nagios_object_new_name_settings_serial != 'undefined') { */
		else {
			$nagios_object_new_name_settings = '';
			} /* End else { */

		/* Get the Nagios Object New Address Values */
		$nagios_object_new_address_settings_serial = urldecode(grab_request_var('nagios_object_new_address_settings_serial',false));
		if ($nagios_object_new_address_settings_serial != 'undefined') {
			$nagios_object_new_address_settings = unserialize(base64_decode($nagios_object_new_address_settings_serial));
			} /* End if ($nagios_object_new_address_settings_serial != 'undefined') { */
		else {
			$nagios_object_new_address_settings = '';
			} /* End else { */
		
		switch ($vmwarevirtualizationwizard_request) {
			case 'retrieve_datastores':
				/* Get the Datastore Checkbox Settings */
				$datastore_checkbox_settings_serial = urldecode(grab_request_var('datastore_checkbox_settings_serial',false));
				if ($datastore_checkbox_settings_serial != 'undefined') {
					$datastore_checkbox_settings = unserialize(base64_decode($datastore_checkbox_settings_serial));
					} /* End if ($datastore_checkbox_settings_serial != 'undefined') { */
				else {
					$datastore_checkbox_settings = '';
					} /* End else { */
					
				/* Define the command */
				$datastore_command = '/usr/local/nagios/libexec/check_by_ssh -E 1 -t 90 -l vi-admin -H '.$vma_host_select.' -C "~/box293_check_vmware.pl --timeout 90 --server '.$vma_host_object_select.' --check List_Datastores"';

				/* Execute the command */
				exec($datastore_command, $datastore_results, $datastore_exit_code);
				
				/* Turn the results into one string */
				$datastore_results_encoded = '';
				foreach ($datastore_results as $line) {
					$datastore_results_encoded .= $line;
					} /* End foreach ($datastore_results as $line) { */

				/* Decode the results */
				$datastore_results_decoded = json_decode(base64_decode($datastore_results_encoded),true);

				$vmwarevirtualizationwizard_output .= '<div class="'.$wizard_name.'-spacer10"> </div>';

				/* Check to make sure the plugin did not time out */
				if (preg_match("/^CRITICAL - Plugin timed out/", $datastore_results_encoded) == 0) {
					/* Check to make sure there are more than 0 results */
					if (count($datastore_results_decoded['datastores']) != 0) {
						/* Define the Datastore counter */
						$datastore_counter = 0;

						/* Get the hosts already defined in Nagios */
						$args = array(
							'is_active' => 1,
							'orderby' => 'host_name:a',
							);
						$xmlhosts = get_xml_host_objects($args);
						#foreach($xmlhosts->host as $h){
						#	print_r($h->host_name . " = " . $h->address . "<br/>");
						#	} /* End foreach($xmlhosts->host as $h){ */


						$vmwarevirtualizationwizard_output .= '
							<div id="'.$wizard_name.'-datastore-objects" style="display:none">
								<input type="checkbox" name="datastore_checkbox['.$datastore_counter.']" value="'.$vma_host_object_select.'" checked>
							</div>

							Datastore checks fall into two categories, Usage and Performance.

							<div class="'.$wizard_name.'-spacer10"> </div>

							<b>Performance</b> checks are specific to the host that is connected to it. Hence these checks are created when configuring hosts.

							<div class="'.$wizard_name.'-spacer10"> </div>

							<b>Usage</b> checks do not need to be tied to any specific host. For these checks they are assigned to the vCenter Server OR the ESX(i) host you have selected above.

							<div class="'.$wizard_name.'-spacer10"> </div>

							For the vCenter Server OR ESX(i) host you selected above, these datastore checks need to be associated with a Nagios Host Object.

							<div class="'.$wizard_name.'-spacer20"> </div>

							Did you want to use an Existing Nagios Host Object or create a New Nagios Host Object?

							<div class="'.$wizard_name.'-spacer20"> </div>
						
							<table>
							<thead><tr><th class="'.$wizard_name.'-width120 '.$wizard_name.'-align-top">Nagios Host<br/>Object</th><th class=" '.$wizard_name.'-align-top">Nagios Host Object<br>Existing or Name & Address</th></tr></thead>
							<tr>
							';

						/* Backwards, creating the host_name select first to determine host object select "selected" item */
						$vmwarevirtualizationwizard_output_select_host_name = '
							<select name="nagios_object_existing['.$datastore_counter.']">
								<option value=""></option>
								';
						/* Loop through the existing hosts to create a select */
						$selection_flag = 0;
						foreach($xmlhosts->host as $h){
							/* Check if this host was already selected */
							if ($nagios_object_existing_settings != '') {
								if (isset($nagios_object_existing_settings[$datastore_counter])) {
									if (($nagios_object_existing_settings[$datastore_counter] == $h->address) or ($nagios_object_existing_settings[$datastore_counter] == $h->host_name)) {
										if ($selection_flag == 0) {
											$selection = ' selected';
											} /* End if ($selection_flag == 0) { */
										else {
											$selection = '';
											} /* End else { */
										$selection_flag = 1;
										} /* End if (($nagios_object_existing_settings[$datastore_counter] == $h->address) or ($nagios_object_existing_settings[$datastore_counter] == $h->host_name)) { */
									else {
										$selection = '';
										} /* End else { */
									} /* End if (isset($nagios_object_existing_settings[$datastore_counter])) { */
								else {
									$selection = '';
									} /* End else { */
								} /* End if ($nagios_object_existing_settings != '') { */
							else {
								if (($vma_host_object_select == $h->address) or ($vma_host_object_select == $h->host_name)) {
									if ($selection_flag == 0) {
										$selection = ' selected';
										} /* End if ($selection_flag == 0) { */
									else {
										$selection = '';
										} /* End else { */
									$selection_flag = 1;
									} /* End if (($vma_host_object_select == $h->address) or ($vma_host_object_select == $h->host_name)) { */
								else {
									$selection = '';
									} /* End else { */
								} /* End else { */
							$vmwarevirtualizationwizard_output_select_host_name .= '<option value="'.$h->host_name.'"'.$selection.'>'.$h->host_name.'</option>';
							} /* End foreach($xmlhosts->host as $h){ */

						$vmwarevirtualizationwizard_output_select_host_name .= '
							</select>
							';

						/* Now create the select for Nagios Host Object */
						if (isset($nagios_object_settings[$datastore_counter])) {
							if ($nagios_object_settings[$datastore_counter] == 'new') {	
								$selection_flag = 0;
								} /* End if ($nagios_object_settings[$datastore_counter] == 'new') { */
							else {
								$selection_flag = 1;
								} /* End else { */
							} /* End if (isset($nagios_object_settings[$datastore_counter])) { */
						$vmwarevirtualizationwizard_output_select_host_object = '
							<select name="nagios_object['.$datastore_counter.']" id="id_nagios_object['.$datastore_counter.']" title="Create New Nagios Host Object or Use Existing?" onChange="'.$wizard_name.'_nagios_host_object(\''.$datastore_counter.'\')">
								<option value="new"'; if ($selection_flag == 0) $vmwarevirtualizationwizard_output_select_host_object .= ' selected'; $vmwarevirtualizationwizard_output_select_host_object .= '>New</option>
								<option value="existing"'; if ($selection_flag == 1) $vmwarevirtualizationwizard_output_select_host_object .= ' selected'; $vmwarevirtualizationwizard_output_select_host_object .= '>Existing</option>
							</select>
							';

						/* Add the host object select */
						$vmwarevirtualizationwizard_output .= '
							<td class="'.$wizard_name.'-align-center">
							'.$vmwarevirtualizationwizard_output_select_host_object.'
							</td>
							';

						/* Add the host name select */
						$vmwarevirtualizationwizard_output .= '
							<td>
							<div id="'.$wizard_name.'-nagios-object-new-'.$datastore_counter.'" style="display:none">
								<table>
									<tr><td>Name:</td><td><input type="text" name="nagios_object_new_name['.$datastore_counter.']" id="id_nagios_object_new_name['.$datastore_counter.']"'; if (isset($nagios_object_new_name_settings[$datastore_counter])) $vmwarevirtualizationwizard_output .= ' value="'.$nagios_object_new_name_settings[$datastore_counter].'"'; $vmwarevirtualizationwizard_output .= ' class="vmwarevmasettingsmanager-width250"/></td></tr>
									<tr><td>Address:</td><td><input type="text" name="nagios_object_new_address['.$datastore_counter.']" id="id_nagios_object_new_address['.$datastore_counter.']"'; if (isset($nagios_object_new_address_settings[$datastore_counter])) {$vmwarevirtualizationwizard_output .= ' value="'.$nagios_object_new_address_settings[$datastore_counter].'"';} else {$vmwarevirtualizationwizard_output .= ' value="'.$vma_host_object_select.'"';} $vmwarevirtualizationwizard_output .= ' class="vmwarevmasettingsmanager-width250"/></td></tr>
								</table>
							</div>
							<div id="'.$wizard_name.'-nagios-object-existing-'.$datastore_counter.'" style="display:none" class="'.$wizard_name.'-align-center">
								'.$vmwarevirtualizationwizard_output_select_host_name.'
							</div>
							</td>
							</tr>
							</table>
							<script>'.$wizard_name.'_nagios_host_object(\''.$datastore_counter.'\')</script>
							';

						/* Increment the Datastore counter */
						$datastore_counter++;

						$vmwarevirtualizationwizard_output .= '
							<div class="'.$wizard_name.'-spacer20"> </div>
							
							<table>
							<thead><tr><th class="'.$wizard_name.'-width80 '.$wizard_name.'-align-center '.$wizard_name.'-align-top">Select<br/>Datastore<br/><input type="checkbox" name="datastore_checkbox_all" id="id_datastore_checkbox_all" value="off" onclick="'.$wizard_name.'_ToggleCheckbox(\'id_datastore_checkbox_all:datastore-checkbox\')"></th><th class="'.$wizard_name.'-width150 '.$wizard_name.'-align-top-left">Datastore Name</th><th class="'.$wizard_name.'-align-top">Datastore<br/>Size (GB)</th><th class="'.$wizard_name.'-width80 '.$wizard_name.'-align-top">Datastore<br/>Type</th></tr></thead>
								<tr><td> </td></tr>
							';

						/* Now loop through the decoded results */
						foreach ($datastore_results_decoded['datastores'] as $item) {
							$vmwarevirtualizationwizard_output .= '
								<tr>
								<td class="'.$wizard_name.'-align-center"><input type="checkbox" name="datastore_checkbox['.$datastore_counter.']" value="'.$item['datastore_name'].'"'; if (isset($datastore_checkbox_settings[$datastore_counter])) $vmwarevirtualizationwizard_output .= ' checked'; $vmwarevirtualizationwizard_output .= ' class="datastore-checkbox"></td>
								<td class="'.$wizard_name.'-padding-left-right-10">'.$item['datastore_name'].'</td>
								<td class="'.$wizard_name.'-align-center">'.$item['datastore_size'].'</td>
								<td class="'.$wizard_name.'-align-center">'.$item['datastore_type'].'</td>
								';
							/* Increment the Datastore counter */
							$datastore_counter++;
							} /* End foreach ($datastore_results_decoded['datastores'] as $item) { */

						$vmwarevirtualizationwizard_output .= '
							</table>
							<input type="hidden" name="datastore_results_encoded" id="datastore_results_encoded" value="'.$datastore_results_encoded.'">
							<input type="hidden" name="datastore_counter" value="'.$datastore_counter.'">
							';
						} /* End if (count($datastore_results_decoded['datastores']) != 0) { */
					else {
						$vmwarevirtualizationwizard_output .= 'No datastores found!';
						} /* End else { */
					} /* End if (preg_match("/^CRITICAL - Plugin timed out/", $datastore_results_encoded) == 0) { */
				else {
					$vmwarevirtualizationwizard_output .= 'Plugin timed out!';
					} /* End else { */
				break; /* End case 'retrieve_datastores': */


			case 'retrieve_guests':
				/* Get the Guest Checkbox Settings */
				$guest_checkbox_settings_serial = urldecode(grab_request_var('guest_checkbox_settings_serial',false));
				if ($guest_checkbox_settings_serial != 'undefined') {
					$guest_checkbox_settings = unserialize(base64_decode($guest_checkbox_settings_serial));
					} /* End if ($guest_checkbox_settings_serial != 'undefined') { */
				else {
					$guest_checkbox_settings = '';
					} /* End else { */
					
				/* Define the command */
				$guest_command = '/usr/local/nagios/libexec/check_by_ssh -E 1 -t 90 -l vi-admin -H '.$vma_host_select.' -C "~/box293_check_vmware.pl --timeout 90 --server '.$vma_host_object_select.' --check List_Guests"';

				/* Execute the command */
				exec($guest_command, $guest_results, $guest_exit_code);
				
				/* Turn the results into one string */
				$guest_results_encoded = '';
				foreach ($guest_results as $line) {
					$guest_results_encoded .= $line;
					} /* End foreach ($guest_results as $line) { */

				/* Decode the results */
				$guest_results_decoded = json_decode(base64_decode($guest_results_encoded),true);

				$vmwarevirtualizationwizard_output .= '<div class="'.$wizard_name.'-spacer10"> </div>';

				/* Check to make sure the plugin did not time out */
				if (preg_match("/^CRITICAL - Plugin timed out/", $guest_results_encoded) == 0) {
					/* Check to make sure there are more than 0 results */
					if (count($guest_results_decoded['guests']) != 0) {
						$vmwarevirtualizationwizard_output .= '
							<table>
							<thead><tr><th class="'.$wizard_name.'-width40 '.$wizard_name.'-align-top">Select<br/>Guest</br/><input type="checkbox" name="guest_checkbox_all" id="id_guest_checkbox_all" value="off" onclick="'.$wizard_name.'_ToggleCheckbox(\'id_guest_checkbox_all:guest-checkbox\')"></th><th class="'.$wizard_name.'-width60 '.$wizard_name.'-align-top">Power<br/>State</th><th class="'.$wizard_name.'-align-top-left">Guest Name</th><th class="'.$wizard_name.'-align-top-left">Guest DNS Name</th><th class="'.$wizard_name.'-width120 '.$wizard_name.'-align-top">Nagios Host<br/>Object</th><th class=" '.$wizard_name.'-align-top">Nagios Host Object<br>Existing or Name & Address</th></tr></thead>
								<tr><td> </td></tr>
							';
						
						/* Define the Guest counter */
						$guest_counter = 0;

						/* Get the hosts already defined in Nagios */
						$args = array(
							'is_active' => 1,
							'orderby' => 'host_name:a',
							);
						$xmlhosts = get_xml_host_objects($args);
						#foreach($xmlhosts->host as $h){
						#	print_r($h->host_name . " = " . $h->address . "<br/>");
						#	} /* End foreach($xmlhosts->host as $h){ */

						/* Now loop through the decoded results */
						foreach ($guest_results_decoded['guests'] as $item) {
							$vmwarevirtualizationwizard_output .= '
								<tr>
								<td class="'.$wizard_name.'-align-center"><input type="checkbox" name="guest_checkbox['.$guest_counter.']" value="'.$item['guest_name'].'"'; if (isset($guest_checkbox_settings[$guest_counter])) $vmwarevirtualizationwizard_output .= ' checked'; $vmwarevirtualizationwizard_output .= ' class="guest-checkbox"></td>
								<td class="'.$wizard_name.'-align-center">
								';
							switch ($item['guest_power_state']) {
								case 'poweredOff':
									$vmwarevirtualizationwizard_output .= 'Off';
									break; /* End case 'poweredOff': */

								case 'poweredOn':
									$vmwarevirtualizationwizard_output .= '<b>On</b>';
									break; /* End case 'poweredOn': */

								case 'suspended':
									$vmwarevirtualizationwizard_output .= 'Suspended';
									break; /* End case 'suspended': */
								} /* End switch ($item['guest_power_state']) { */

							$vmwarevirtualizationwizard_output .= '
								</td>
								<td>'.$item['guest_name'].'</td>
								<td>'.$item['guest_hostname'].'</td>
								';
							
							/* Backwards, creating the host_name select first to determine host object select "selected" item */
							$vmwarevirtualizationwizard_output_select_host_name = '
								<select name="nagios_object_existing['.$guest_counter.']">
									<option value=""></option>
									';
							/* Loop through the existing hosts to create a select */
							$selection_flag = 0;
							foreach($xmlhosts->host as $h){
								/* Check if this guest was already selected */
								if ($nagios_object_existing_settings != '') {
									if (isset($nagios_object_existing_settings[$guest_counter])) {
										if (($nagios_object_existing_settings[$guest_counter] == $h->address) or ($nagios_object_existing_settings[$guest_counter] == $h->host_name)) {
											if ($selection_flag == 0) {
												$selection = ' selected';
												} /* End if ($selection_flag == 0) { */
											else {
												$selection = '';
												} /* End else { */
											$selection_flag = 1;
											} /* End if (($nagios_object_existing_settings[$guest_counter] == $h->address) or ($nagios_object_existing_settings[$guest_counter] == $h->host_name)) { */
										else {
											$selection = '';
											} /* End else { */
										} /* End if (isset($nagios_object_existing_settings[$guest_counter])) { */
									else {
										$selection = '';
										} /* End else { */
									} /* End if ($nagios_object_existing_settings != '') { */
								else {
									if (($item['guest_address'] == $h->address) or ($item['guest_hostname'] == $h->address) or ($item['guest_address'] == $h->host_name) or ($item['guest_hostname'] == $h->host_name)) {
										if ($selection_flag == 0) {
											$selection = ' selected';
											} /* End if ($selection_flag == 0) { */
										else {
											$selection = '';
											} /* End else { */
										$selection_flag = 1;
										} /* End if (($item['guest_address'] == $h->address) or ($item['guest_hostname'] == $h->address) or ($item['guest_address'] == $h->host_name) or ($item['guest_hostname'] == $h->host_name)) { */
									else {
										$selection = '';
										} /* End else { */
									} /* End else { */
								$vmwarevirtualizationwizard_output_select_host_name .= '<option value="'.$h->host_name.'"'.$selection.'>'.$h->host_name.'</option>';
								} /* End foreach($xmlhosts->host as $h){ */

							$vmwarevirtualizationwizard_output_select_host_name .= '
								</select>
								';

							/* Now create the select for Nagios Host Object */
							if (isset($nagios_object_settings[$guest_counter])) {
								if ($nagios_object_settings[$guest_counter] == 'new') {	
									$selection_flag = 0;
									} /* End if ($nagios_object_settings[$guest_counter] == 'new') { */
								else {
									$selection_flag = 1;
									} /* End else { */
								} /* End if (isset($nagios_object_settings[$guest_counter])) { */
							$vmwarevirtualizationwizard_output_select_host_object = '
								<select name="nagios_object['.$guest_counter.']" id="id_nagios_object['.$guest_counter.']" title="Create New Nagios Host Object or Use Existing?" onChange="'.$wizard_name.'_nagios_host_object(\''.$guest_counter.'\')">
									<option value="new"'; if ($selection_flag == 0) $vmwarevirtualizationwizard_output_select_host_object .= ' selected'; $vmwarevirtualizationwizard_output_select_host_object .= '>New</option>
									<option value="existing"'; if ($selection_flag == 1) $vmwarevirtualizationwizard_output_select_host_object .= ' selected'; $vmwarevirtualizationwizard_output_select_host_object .= '>Existing</option>
								</select>
								';

							/* Add the host object select */
							$vmwarevirtualizationwizard_output .= '
								<td class="'.$wizard_name.'-align-center">
								'.$vmwarevirtualizationwizard_output_select_host_object.'
								</td>
								';

							/* Add the host name select */
							$vmwarevirtualizationwizard_output .= '
								<td>
								<div id="'.$wizard_name.'-nagios-object-new-'.$guest_counter.'" style="display:none">
									<table>
										<tr><td>Name:</td><td><input type="text" name="nagios_object_new_name['.$guest_counter.']" id="id_nagios_object_new_name['.$guest_counter.']"'; if (isset($nagios_object_new_name_settings[$guest_counter])) $vmwarevirtualizationwizard_output .= ' value="'.$nagios_object_new_name_settings[$guest_counter].'"'; $vmwarevirtualizationwizard_output .= ' class="vmwarevmasettingsmanager-width250"/></td></tr>
										<tr><td>Address:</td><td><input type="text" name="nagios_object_new_address['.$guest_counter.']" id="id_nagios_object_new_address['.$guest_counter.']"'; if (isset($nagios_object_new_address_settings[$guest_counter])) $vmwarevirtualizationwizard_output .= ' value="'.$nagios_object_new_address_settings[$guest_counter].'"'; $vmwarevirtualizationwizard_output .= ' class="vmwarevmasettingsmanager-width250"/></td></tr>
									</table>
								</div>
								<div id="'.$wizard_name.'-nagios-object-existing-'.$guest_counter.'" style="display:none" class="'.$wizard_name.'-align-center">
									'.$vmwarevirtualizationwizard_output_select_host_name.'
								</div>
								</td>
								</tr>	

								<script>'.$wizard_name.'_nagios_host_object(\''.$guest_counter.'\')</script>
								';
							
							/* Increment the Guest counter */
							$guest_counter++;
							} /* End foreach ($guest_results_decoded['guests'] as $item) { */

						$vmwarevirtualizationwizard_output .= '</table>';

						$vmwarevirtualizationwizard_output .= '<input type="hidden" name="guest_results_encoded" id="guest_results_encoded" value="'.$guest_results_encoded.'">';
						$vmwarevirtualizationwizard_output .= '<input type="hidden" name="guest_counter" value="'.$guest_counter.'">';
						} /* End if (count($guest_results_decoded['guests']) != 0) { */
					else {
						$vmwarevirtualizationwizard_output .= 'No guests found!';
						} /* End else { */
					} /* End if (preg_match("/^CRITICAL - Plugin timed out/", $guest_results_encoded) == 0) { */
				else {
					$vmwarevirtualizationwizard_output .= 'Plugin timed out!';
					} /* End else { */
				break; /* End case 'retrieve_guests': */
				

			case 'retrieve_hosts':
				/* Get the Host Checkbox Settings */
				$host_checkbox_settings_serial = urldecode(grab_request_var('host_checkbox_settings_serial',false));
				if ($host_checkbox_settings_serial != 'undefined') {
					$host_checkbox_settings = unserialize(base64_decode($host_checkbox_settings_serial));
					} /* End if ($host_checkbox_settings_serial != 'undefined') { */
				else {
					$host_checkbox_settings = '';
					} /* End else { */
				
				/* Define the command */
				$host_command = '/usr/local/nagios/libexec/check_by_ssh -E 1 -t 90 -l vi-admin -H '.$vma_host_select.' -C "~/box293_check_vmware.pl --timeout 90 --server '.$vma_host_object_select.' --check List_Hosts"';
				
				/* Execute the command */
				exec($host_command, $host_results, $host_exit_code);
				
				/* Turn the results into one string */
				$host_results_encoded = '';
				foreach ($host_results as $line) {
					$host_results_encoded .= $line;
					} /* End foreach ($host_results as $line) { */
				//$vmwarevirtualizationwizard_output .= $host_results_encoded . '<br/>';

				/* Check to make sure the plugin did not time out */
				if (preg_match("/^CRITICAL - Plugin timed out/", $host_results_encoded) == 0) {
					/* Decode the results */
					$host_results_decoded = json_decode(base64_decode($host_results_encoded),true);

					$vmwarevirtualizationwizard_output .= '<div class="'.$wizard_name.'-spacer10"> </div>';

					/* Check to make sure there are more than 0 results */
					if (count($host_results_decoded['hosts']) != 0) {
						$vmwarevirtualizationwizard_output .= '
							<table>
							<thead><tr><th class="'.$wizard_name.'-width40 '.$wizard_name.'-align-top">Select<br/>Host<br/><input type="checkbox" name="host_checkbox_all" id="id_host_checkbox_all" value="off" onclick="'.$wizard_name.'_ToggleCheckbox(\'id_host_checkbox_all:host-checkbox\')"></th><th class="'.$wizard_name.'-width60 '.$wizard_name.'-align-top">Power<br/>State</th><th class="'.$wizard_name.'-width80 '.$wizard_name.'-align-top">Maintenance<br/>Mode</th><th class="'.$wizard_name.'-align-center '.$wizard_name.'-align-top">Host Name</th><th class="'.$wizard_name.'-width120 '.$wizard_name.'-align-top">Nagios Host<br/>Object</th><th class=" '.$wizard_name.'-align-top">Nagios Host Object<br>Existing or Name & Address</th></tr></thead>
								<tr><td> </td></tr>
							';
						
						/* Define the Host counter */
						$host_counter = 0;

						/* Get the hosts already defined in Nagios */
						$args = array(
							'is_active' => 1,
							'orderby' => 'host_name:a',
							);
						$xmlhosts = get_xml_host_objects($args);
						#foreach($xmlhosts->host as $h){
						#	print_r($h->host_name . " = " . $h->address . "<br/>");
						#	} /* End foreach($xmlhosts->host as $h){ */

						/* Now loop through the decoded results */
						foreach ($host_results_decoded['hosts'] as $item) {
							$vmwarevirtualizationwizard_output .= '
								<tr>
								<td class="'.$wizard_name.'-align-center"><input type="checkbox" name="host_checkbox['.$host_counter.']" value="'.$item['host_name'].'"'; if (isset($host_checkbox_settings[$host_counter])) $vmwarevirtualizationwizard_output .= ' checked'; $vmwarevirtualizationwizard_output .= ' class="host-checkbox"></td>
								<td class="'.$wizard_name.'-align-center">
								';
							switch ($item['host_power_state']) {
								case 'poweredOff':
									$vmwarevirtualizationwizard_output .= 'Off';
									break; /* End case 'poweredOff': */

								case 'poweredOn':
									$vmwarevirtualizationwizard_output .= '<b>On</b>';
									break; /* End case 'poweredOn': */

								case 'suspended':
									$vmwarevirtualizationwizard_output .= 'Suspended';
									break; /* End case 'suspended': */

								default:
									$vmwarevirtualizationwizard_output .= $item['host_power_state'];
									break; /* End default: */
								} /* End switch ($item['host_power_state']) { */
							$vmwarevirtualizationwizard_output .= '</td>';
							
							$vmwarevirtualizationwizard_output .= '<td class="'.$wizard_name.'-align-center">';
							switch ($item['host_maintenance_mode']) {
								case 'true':
									$vmwarevirtualizationwizard_output .= 'Yes';
									break; /* End case 'true': */

								case 'false':
									$vmwarevirtualizationwizard_output .= 'No';
									break; /* End case 'false': */
								} /* End switch ($item['host_maintenance_mode']) { */
							$vmwarevirtualizationwizard_output .= '
								</td>
								<td class="'.$wizard_name.'-padding-left-right-10">'.$item['host_name'].'</td>
								';

							/* Backwards, creating the host_name select first to determine host object select "selected" item */
							$vmwarevirtualizationwizard_output_select_host_name = '
								<select name="nagios_object_existing['.$host_counter.']">
									<option value=""></option>
									';
							/* Loop through the existing hosts to create a select */
							$selection_flag = 0;
							foreach($xmlhosts->host as $h){
								/* Check if this host was already selected */
								if ($nagios_object_existing_settings != '') {
									if (isset($nagios_object_existing_settings[$host_counter])) {
										if (($nagios_object_existing_settings[$host_counter] == $h->address) or ($nagios_object_existing_settings[$host_counter] == $h->host_name)) {
											if ($selection_flag == 0) {
												$selection = ' selected';
												} /* End if ($selection_flag == 0) { */
											else {
												$selection = '';
												} /* End else { */
											$selection_flag = 1;
											} /* End if (($nagios_object_existing_settings[$host_counter] == $h->address) or ($nagios_object_existing_settings[$host_counter] == $h->host_name)) { */
										else {
											$selection = '';
											} /* End else { */
										} /* End if (isset($nagios_object_existing_settings[$host_counter]) { */
									else {
										$selection = '';
										} /* End else { */
									} /* End if ($nagios_object_existing_settings != '') { */
								else {
									/* Otherwise check to see if this host matches an existing Nagios Host Object */
									if (($item['host_name'] == $h->address) or ($item['host_name'] == $h->host_name)) {
										if ($selection_flag == 0) {
											$selection = ' selected';
											} /* End if ($selection_flag == 0) { */
										else {
											$selection = '';
											} /* End else { */
										$selection_flag = 1;
										} /* End if (($item['host_name'] == $h->address) or ($item['host_name'] == $h->host_name)) { */
									else {
										$selection = '';
										} /* End else { */
									} /* End else { */
								$vmwarevirtualizationwizard_output_select_host_name .= '<option value="'.$h->host_name.'"'.$selection.'>'.$h->host_name.'</option>';
								} /* End foreach($xmlhosts->host as $h){ */
							$vmwarevirtualizationwizard_output_select_host_name .= '
								</select>
								';

							/* Now create the select for Nagios Host Object */
							if (isset($nagios_object_settings[$host_counter])) {
								if ($nagios_object_settings[$host_counter] == 'new') {	
									$selection_flag = 0;
									} /* End if ($nagios_object_settings[$host_counter] == 'new') { */
								else {
									$selection_flag = 1;
									} /* End else { */
								} /* End if (isset($nagios_object_settings[$host_counter])) { */
							$vmwarevirtualizationwizard_output_select_host_object = '
								<select name="nagios_object['.$host_counter.']" id="id_nagios_object['.$host_counter.']" title="Create New Nagios Host Object or Use Existing?" onChange="'.$wizard_name.'_nagios_host_object(\''.$host_counter.'\')">
									<option value="new"'; if ($selection_flag == 0) $vmwarevirtualizationwizard_output_select_host_object .= ' selected'; $vmwarevirtualizationwizard_output_select_host_object .= '>New</option>
									<option value="existing"'; if ($selection_flag == 1) $vmwarevirtualizationwizard_output_select_host_object .= ' selected'; $vmwarevirtualizationwizard_output_select_host_object .= '>Existing</option>
								</select>
								';

							/* Add the host object select */
							$vmwarevirtualizationwizard_output .= '
								<td class="'.$wizard_name.'-align-center">
								'.$vmwarevirtualizationwizard_output_select_host_object.'
								</td>
								';

							/* Add the host name select */
							$vmwarevirtualizationwizard_output .= '
								<td>
								<div id="'.$wizard_name.'-nagios-object-new-'.$host_counter.'" style="display:none">
									<table>
										<tr><td>Name:</td><td><input type="text" name="nagios_object_new_name['.$host_counter.']" id="id_nagios_object_new_name['.$host_counter.']"'; if (isset($nagios_object_new_name_settings[$host_counter])) $vmwarevirtualizationwizard_output .= ' value="'.$nagios_object_new_name_settings[$host_counter].'"'; $vmwarevirtualizationwizard_output .= ' class="vmwarevmasettingsmanager-width250"/></td></tr>
										<tr><td>Address:</td><td><input type="text" name="nagios_object_new_address['.$host_counter.']" id="id_nagios_object_new_address['.$host_counter.']"'; if (isset($nagios_object_new_address_settings[$host_counter])) $vmwarevirtualizationwizard_output .= ' value="'.$nagios_object_new_address_settings[$host_counter].'"'; $vmwarevirtualizationwizard_output .= ' class="vmwarevmasettingsmanager-width250"/></td></tr>
									</table>
								</div>
								<div id="'.$wizard_name.'-nagios-object-existing-'.$host_counter.'" style="display:none" class="'.$wizard_name.'-align-center">
									'.$vmwarevirtualizationwizard_output_select_host_name.'
								</div>
								</td>
								</tr>	

								<script>'.$wizard_name.'_nagios_host_object(\''.$host_counter.'\')</script>
								';
								
							/* Increment the Host counter */
							$host_counter++;
							} /* End foreach ($host_results_decoded['hosts'] as $item) { */

						$vmwarevirtualizationwizard_output .= '</table>';

						$vmwarevirtualizationwizard_output .= '<input type="hidden" name="host_results_encoded" id="host_results_encoded" value="'.$host_results_encoded.'">';
						$vmwarevirtualizationwizard_output .= '<input type="hidden" name="host_counter" value="'.$host_counter.'">';
						} /* End if (count($host_results_decoded['hosts']) != 0) { */
					else {
						$vmwarevirtualizationwizard_output .= 'No hosts found!';
						} /* End else { */
					} /* End if (preg_match("/^CRITICAL - Plugin timed out/", $host_results_encoded) == 0) { */
				else {
					$vmwarevirtualizationwizard_output .= 'Plugin timed out!';
					} /* End else { */
				break; /* End case 'retrieve_hosts': */


			case 'retrieve_vcenter':
				/* Get the vCenter Checkbox Settings */
				$vcenter_checkbox_settings_serial = urldecode(grab_request_var('vcenter_checkbox_settings_serial',false));
				if ($vcenter_checkbox_settings_serial != 'undefined') {
					$vcenter_checkbox_settings = unserialize(base64_decode($vcenter_checkbox_settings_serial));
					} /* End if ($vcenter_checkbox_settings_serial != 'undefined') { */
				else {
					$vcenter_checkbox_settings = '';
					} /* End else { */

				$vcenter_command = '/usr/local/nagios/libexec/check_by_ssh -E 1 -t 90 -l vi-admin -H '.$vma_host_select.' -C "~/box293_check_vmware.pl --timeout 90 --server '.$vma_host_object_select.' --check List_vCenter_Objects"';

				/* Execute the command */
				exec($vcenter_command, $vcenter_results, $vcenter_exit_code);
				
				/* Turn the results into one string */
				$vcenter_results_encoded = '';
				foreach ($vcenter_results as $line) {
					$vcenter_results_encoded .= $line;
					} /* End foreach ($vcenter_results as $line) { */

				/* Check to make sure the plugin did not time out */
				if (preg_match("/^CRITICAL - Plugin timed out/", $vcenter_results_encoded) == 0) {
					/* Decode the results */
					$vcenter_results_decoded = json_decode(base64_decode($vcenter_results_encoded),true);

					$vmwarevirtualizationwizard_output .= '<div class="'.$wizard_name.'-spacer10"> </div>';

					/* Check to make sure there are more than 0 results */
					if (count($vcenter_results_decoded['datacenters']) != 0) {
						/* Define the vCenter counter */
						$vcenter_counter = 0;

						/* Get the hosts already defined in Nagios */
						$args = array(
							'is_active' => 1,
							'orderby' => 'host_name:a',
							);
						$xmlhosts = get_xml_host_objects($args);
						#foreach($xmlhosts->host as $h){
						#	print_r($h->host_name . " = " . $h->address . "<br/>");
						#	} /* End foreach($xmlhosts->host as $h){ */

						$vmwarevirtualizationwizard_output .= '
							<div id="'.$wizard_name.'-vcenter-objects" style="display:none">
								<input type="checkbox" name="vcenter_checkbox['.$vcenter_counter.']" value="'.$vma_host_select.'" checked>
							</div>

							For the vCenter Server you selected above, any vCenter specific checks need to be associated with a Nagios Host Object.

							<div class="'.$wizard_name.'-spacer20"> </div>

							Did you want to use an Existing Nagios Host Object or create a New Nagios Host Object?

							<div class="'.$wizard_name.'-spacer20"> </div>
						
							<table>
							<thead><tr><th class="'.$wizard_name.'-width120 '.$wizard_name.'-align-top">Nagios Host<br/>Object</th><th class="'.$wizard_name.'-align-top">Nagios Host Object<br>Existing or Name & Address</th></tr></thead>
							<tr>
							';
						
						/* Backwards, creating the host_name select first to determine host object select "selected" item */
						$vmwarevirtualizationwizard_output_select_host_name = '
							<select name="nagios_object_existing['.$vcenter_counter.']">
								<option value=""></option>
								';
						/* Loop through the existing hosts to create a select */
						$selection_flag = 0;
						foreach($xmlhosts->host as $h){
							/* Check if this host was already selected */
							if ($nagios_object_existing_settings != '') {
								if (isset($nagios_object_existing_settings[$vcenter_counter])) {
									if (($nagios_object_existing_settings[$vcenter_counter] == $h->address) or ($nagios_object_existing_settings[$vcenter_counter] == $h->host_name)) {
										if ($selection_flag == 0) {
											$selection = ' selected';
											} /* End if ($selection_flag == 0) { */
										else {
											$selection = '';
											} /* End else { */
										$selection_flag = 1;
										} /* End if (($nagios_object_existing_settings[$vcenter_counter] == $h->address) or ($nagios_object_existing_settings[$vcenter_counter] == $h->host_name)) { */
									else {
										$selection = '';
										} /* End else { */
									} /* End if (isset($nagios_object_existing_settings[$vcenter_counter])) { */
								else {
									$selection = '';
									} /* End else { */
								} /* End if ($nagios_object_existing_settings != '') { */
							else {
								if (($vma_host_object_select == $h->address) or ($vma_host_object_select == $h->host_name)) {
									if ($selection_flag == 0) {
										$selection = ' selected';
										} /* End if ($selection_flag == 0) { */
									else {
										$selection = '';
										} /* End else { */
									$selection_flag = 1;
									} /* End if (($vma_host_object_select == $h->address) or ($vma_host_object_select == $h->host_name)) { */
								else {
									$selection = '';
									} /* End else { */
								} /* End else { */
							$vmwarevirtualizationwizard_output_select_host_name .= '<option value="'.$h->host_name.'"'.$selection.'>'.$h->host_name.'</option>';
							} /* End foreach($xmlhosts->host as $h){ */

						$vmwarevirtualizationwizard_output_select_host_name .= '
							</select>
							';

						/* Now create the select for Nagios Host Object */
						if (isset($nagios_object_settings[$vcenter_counter])) {
							if ($nagios_object_settings[$vcenter_counter] == 'new') {	
								$selection_flag = 0;
								} /* End if ($nagios_object_settings[$vcenter_counter] == 'new') { */
							else {
								$selection_flag = 1;
								} /* End else { */
							} /* End if (isset($nagios_object_settings[$vcenter_counter])) { */
						$vmwarevirtualizationwizard_output_select_host_object = '
							<select name="nagios_object['.$vcenter_counter.']" id="id_nagios_object['.$vcenter_counter.']" title="Create New Nagios Host Object or Use Existing?" onChange="'.$wizard_name.'_nagios_host_object(\''.$vcenter_counter.'\')">
								<option value="new"'; if ($selection_flag == 0) $vmwarevirtualizationwizard_output_select_host_object .= ' selected'; $vmwarevirtualizationwizard_output_select_host_object .= '>New</option>
								<option value="existing"'; if ($selection_flag == 1) $vmwarevirtualizationwizard_output_select_host_object .= ' selected'; $vmwarevirtualizationwizard_output_select_host_object .= '>Existing</option>
							</select>
							';

						/* Add the host object select */
						$vmwarevirtualizationwizard_output .= '
							<td class="'.$wizard_name.'-align-center">
							'.$vmwarevirtualizationwizard_output_select_host_object.'
							</td>
							';

						/* Add the host name select */
						$vmwarevirtualizationwizard_output .= '
							<td>
							<div id="'.$wizard_name.'-nagios-object-new-'.$vcenter_counter.'" style="display:none">
								<table>
									<tr><td>Name:</td><td><input type="text" name="nagios_object_new_name['.$vcenter_counter.']" id="id_nagios_object_new_name['.$vcenter_counter.']"'; if (isset($nagios_object_new_name_settings[$vcenter_counter])) $vmwarevirtualizationwizard_output .= ' value="'.$nagios_object_new_name_settings[$vcenter_counter].'"'; $vmwarevirtualizationwizard_output .= ' class="vmwarevmasettingsmanager-width250"/></td></tr>
									<tr><td>Address:</td><td><input type="text" name="nagios_object_new_address['.$vcenter_counter.']" id="id_nagios_object_new_address['.$vcenter_counter.']"'; if (isset($nagios_object_new_address_settings[$vcenter_counter])) {$vmwarevirtualizationwizard_output .= ' value="'.$nagios_object_new_address_settings[$vcenter_counter].'"';} else { $vmwarevirtualizationwizard_output .= ' value="'.$vma_host_object_select.'"';} $vmwarevirtualizationwizard_output .= ' class="vmwarevmasettingsmanager-width250"/></td></tr>
								</table>
							</div>
							<div id="'.$wizard_name.'-nagios-object-existing-'.$vcenter_counter.'" style="display:none" class="'.$wizard_name.'-align-center">
								'.$vmwarevirtualizationwizard_output_select_host_name.'
							</div>
							</td>
							</tr>
							</table>
							<script>'.$wizard_name.'_nagios_host_object(\''.$vcenter_counter.'\')</script>
							';

						/* Increment the vCenter counter */
						$vcenter_counter++;
						
						/* Check to see if NO clusters were found */
						#print_r('"' . count($vcenter_results_decoded['clusters']) . '"<br/>');
						if (count($vcenter_results_decoded['clusters']) == 0) {
							$vmwarevirtualizationwizard_output .= '
								<div class="'.$wizard_name.'-spacer20"> </div>
								<div class="'.$wizard_name.'-spacer10"> </div>

								No vCenter clusters were found. Other non-cluster related checks will appear on the next screen.
								';
							} /* End if (count($vcenter_results_decoded['clusters']) == 0) { */
						else {
							/* Clusters found */
							$vmwarevirtualizationwizard_output .= '
								<div class="'.$wizard_name.'-spacer20"> </div>

								If you want to monitor any clusters, please select them below. Other non-cluster related checks will appear on the next screen.

								<div class="'.$wizard_name.'-spacer10"> </div>
								<table>
								<thead><tr><th class="'.$wizard_name.'-width40 '.$wizard_name.'-align-top">Select<br/>Cluster<br/><input type="checkbox" name="vcenter_checkbox_all" id="id_vcenter_checkbox_all" value="off" onclick="'.$wizard_name.'_ToggleCheckbox(\'id_vcenter_checkbox_all:vcenter-checkbox\')"></th><th class="'.$wizard_name.'-align-center '.$wizard_name.'-align-top">Cluster Name</th><th class="'.$wizard_name.'-align-top">DRS</th><th class="'.$wizard_name.'-align-top">HA</th></tr></thead>
									<tr><td> </td></tr>
								';
														
							/* Now loop through the decoded results */
							foreach ($vcenter_results_decoded['clusters'] as $item) {
								$vmwarevirtualizationwizard_output .= '
									<tr>
									<td class="'.$wizard_name.'-align-center"><input type="checkbox" name="vcenter_checkbox['.$vcenter_counter.']" value="'.$item['cluster_name'].'"'; if (isset($vcenter_checkbox_settings[$vcenter_counter])) $vmwarevirtualizationwizard_output .= ' checked'; $vmwarevirtualizationwizard_output .= ' class="vcenter-checkbox"></td>
									<td class="'.$wizard_name.'-padding-left-right-10">'.$item['cluster_name'].'</td>
									<td class="'.$wizard_name.'-padding-left-right-10">'.$item['cluster_drs'].'</td>
									<td class="'.$wizard_name.'-padding-left-right-10">'.$item['cluster_ha'].'</td>
									</tr>
									';

								/* Increment the vCenter counter */
								$vcenter_counter++;
								} /* End foreach ($vcenter_results_decoded['clusters'] as $item) { */

							$vmwarevirtualizationwizard_output .= '</table>';
							} /* End else { */
						
						$vmwarevirtualizationwizard_output .= '<input type="hidden" name="vcenter_results_encoded" id="vcenter_results_encoded" value="'.$vcenter_results_encoded.'">';
						$vmwarevirtualizationwizard_output .= '<input type="hidden" name="vcenter_counter" value="'.$vcenter_counter.'">';
						} /* End if (count($vcenter_results_decoded['datacenters']) != 0) { */
					else {
						$vmwarevirtualizationwizard_output .= 'No vCenter datacenters found!';
						} /* End else { */
					} /* End if (preg_match("/^CRITICAL - Plugin timed out/", $vcenter_results_encoded) == 0) { */
				else {
					$vmwarevirtualizationwizard_output .= 'Plugin timed out!';
					} /* End else { */
				break; /* End case 'retrieve_vcenter': */

			} /* End switch ($vmwarevirtualizationwizard_request) { */
		break; /* End case 'retrieve_datastores': case 'retrieve_guests': case 'retrieve_hosts': case 'retrieve_vcenter': */


	} /* End switch ($vmwarevirtualizationwizard_request) { */


// Display the Output
print $vmwarevirtualizationwizard_output;

?>
